#ifndef _BASECOMMON_H_
#define _BASECOMMON_H_

#include "globus_ftp_client.h"
#include "globus_ftp_control.h"

#define OK 0
#define FAIL 1
#define BUFFER_SIZE (2*1024)

typedef struct monitor_s {
  globus_mutex_t mutex;
  globus_cond_t cond;
  struct monitor_s *monitor;
  volatile globus_bool_t error;
  volatile globus_bool_t done;
} monitor_t; 

int my_vfprintf(FILE *fp, const char *format, va_list ap);
int my_fprintf(FILE *fp, const char *format, ...);
void abort_handler(int signum);
void alarm_handler(int signum);
void setup_timer_and_signals(int timeout);
void callback(void *callback_arg, 
		     globus_ftp_client_handle_t *handle,
		     globus_object_t *error);
void data_callback(void *callback_arg, 
			  globus_ftp_client_handle_t *handle,
			  globus_object_t *error,
			  globus_byte_t *buffer,
			  globus_size_t length,
			  globus_off_t offset,
			  globus_bool_t eof);

#endif /* _BASECOMMON_H_ */
